try:
    import numpy as np
except ImportError:
    import sys
    import subprocess as sp
    sp.check_call([sys.executable, '-m', 'pip', 'install', 'numpy'])
    import numpy as np


class Exercise1:
    def __init__(self):
        pass

    def __call__(self, x:np.array) -> np.array:
        return np.exp(-1.*np.inner(x, x))

    def gradient(self, x:np.array) -> np.array:
        return np.exp(-1.*np.inner(x, x))*-2.*x


class Exercise2:
    def __init__(self):
        pass

    def __call__(self, x:np.array) -> np.array:
        return np.inner(x, x)*np.exp(-1.*x) - x

    def gradient(self, x:np.array) -> np.array:
        return 2.*x*np.exp(-1.*x) - np.inner(x, x)*np.exp(-1.*x) - 1.


